diff --git a/accessible/xpcom/AccEventGen.py b/accessible/xpcom/AccEventGen.py
index 6af54c34db..8b2a46f75b 100755
--- a/accessible/xpcom/AccEventGen.py
+++ b/accessible/xpcom/AccEventGen.py
@@ -40,14 +40,14 @@ def loadEventIDL(parser, includePath, eventname):
 class Configuration:
     def __init__(self, filename):
         config = {}
-        execfile(filename, config)
+        exec(compile(open(filename, "rb").read(), filename, 'exec'), config)
         self.simple_events = config.get('simple_events', [])
 
 def firstCap(str):
     return str[0].upper() + str[1:]
 
 def writeAttributeParams(a):
-    return ("%s a%s" % (a.realtype.nativeType('in'), firstCap(a.name)))
+    return ("{} a{}".format(a.realtype.nativeType('in'), firstCap(a.name)))
 
 def print_header_file(fd, conf, incdirs):
     idl_paths = set()
@@ -64,26 +64,26 @@ def print_header_file(fd, conf, incdirs):
     for e in conf.simple_events:
         idl, idl_path = loadEventIDL(p, incdirs, e)
         idl_paths.add(idl_path)
-        for iface in filter(lambda p: p.kind == "interface", idl.productions):
+        for iface in [p for p in idl.productions if p.kind == "interface"]:
             classname = ("xpcAcc%s" % e)
             baseinterfaces = interfaces(iface)
 
-            fd.write("\nclass %s final : public %s\n" % (classname, iface.name))
+            fd.write("\nclass {} final : public {}\n".format(classname, iface.name))
             fd.write("{\n")
             fd.write("public:\n")
 
             attributes = allAttributes(iface)
-            args = map(writeAttributeParams, attributes)
-            fd.write("  %s(%s) :\n" % (classname, ", ".join(args)))
+            args = list(map(writeAttributeParams, attributes))
+            fd.write("  {}({}) :\n".format(classname, ", ".join(args)))
 
             initializers = []
             for a in attributes:
-                initializers.append("m%s(a%s)" % (firstCap(a.name), firstCap(a.name)))
+                initializers.append("m{}(a{})".format(firstCap(a.name), firstCap(a.name)))
             fd.write("  %s\n  {}\n\n" % ", ".join(initializers))
             fd.write("  NS_DECL_CYCLE_COLLECTING_ISUPPORTS\n")
             fd.write("  NS_DECL_CYCLE_COLLECTION_CLASS(%s)\n" % (classname))
 
-            for iface in filter(lambda i: i.name != "nsISupports", baseinterfaces):
+            for iface in [i for i in baseinterfaces if i.name != "nsISupports"]:
                 fd.write("  NS_DECL_%s\n" % iface.name.upper())
 
             fd.write("\nprivate:\n")
@@ -97,13 +97,13 @@ def print_header_file(fd, conf, incdirs):
     return idl_paths
 
 def interfaceAttributeTypes(idl):
-    ifaces = filter(lambda p: p.kind == "interface", idl.productions)
+    ifaces = [p for p in idl.productions if p.kind == "interface"]
     attributes = []
     for i in ifaces:
         ifaceAttributes = allAttributes(i)
         attributes.extend(ifaceAttributes)
-    ifaceAttrs = filter(lambda a: a.realtype.nativeType("in").endswith("*"), attributes)
-    return map(lambda a: a.realtype.nativeType("in").strip(" *"), ifaceAttrs)
+    ifaceAttrs = [a for a in attributes if a.realtype.nativeType("in").endswith("*")]
+    return [a.realtype.nativeType("in").strip(" *") for a in ifaceAttrs]
 
 def print_cpp(idl, fd, conf, eventname):
     for p in idl.productions:
@@ -118,7 +118,7 @@ def print_cpp_file(fd, conf, incdirs):
     includes = []
     for e in conf.simple_events:
         if not e in includes:
-            includes.append(("nsIAccessible%s" % e))
+            includes.append("nsIAccessible%s" % e)
 
     types = []
     for e in conf.simple_events:
@@ -139,38 +139,38 @@ def print_cpp_file(fd, conf, incdirs):
 
 def attributeVariableTypeAndName(a):
     if a.realtype.nativeType('in').endswith('*'):
-        l = ["nsCOMPtr<%s> m%s;" % (a.realtype.nativeType('in').strip('* '),
+        l = ["nsCOMPtr<{}> m{};".format(a.realtype.nativeType('in').strip('* '),
                    firstCap(a.name))]
     elif a.realtype.nativeType('in').count("nsAString"):
         l = ["nsString m%s;" % firstCap(a.name)]
     elif a.realtype.nativeType('in').count("nsACString"):
         l = ["nsCString m%s;" % firstCap(a.name)]
     else:
-        l = ["%sm%s;" % (a.realtype.nativeType('in'),
+        l = ["{}m{};".format(a.realtype.nativeType('in'),
                        firstCap(a.name))]
     return ", ".join(l)
 
 def writeAttributeGetter(fd, classname, a):
     fd.write("NS_IMETHODIMP\n")
-    fd.write("%s::Get%s(" % (classname, firstCap(a.name)))
+    fd.write("{}::Get{}(".format(classname, firstCap(a.name)))
     if a.realtype.nativeType('in').endswith('*'):
-        fd.write("%s** a%s" % (a.realtype.nativeType('in').strip('* '), firstCap(a.name)))
+        fd.write("{}** a{}".format(a.realtype.nativeType('in').strip('* '), firstCap(a.name)))
     elif a.realtype.nativeType('in').count("nsAString"):
         fd.write("nsAString& a%s" % firstCap(a.name))
     elif a.realtype.nativeType('in').count("nsACString"):
         fd.write("nsACString& a%s" % firstCap(a.name))
     else:
-        fd.write("%s*a%s" % (a.realtype.nativeType('in'), firstCap(a.name)))
+        fd.write("{}*a{}".format(a.realtype.nativeType('in'), firstCap(a.name)))
     fd.write(")\n");
     fd.write("{\n");
     if a.realtype.nativeType('in').endswith('*'):
-        fd.write("  NS_IF_ADDREF(*a%s = m%s);\n" % (firstCap(a.name), firstCap(a.name)))
+        fd.write("  NS_IF_ADDREF(*a{} = m{});\n".format(firstCap(a.name), firstCap(a.name)))
     elif a.realtype.nativeType('in').count("nsAString"):
-        fd.write("  a%s = m%s;\n" % (firstCap(a.name), firstCap(a.name)))
+        fd.write("  a{} = m{};\n".format(firstCap(a.name), firstCap(a.name)))
     elif a.realtype.nativeType('in').count("nsACString"):
-        fd.write("  a%s = m%s;\n" % (firstCap(a.name), firstCap(a.name)))
+        fd.write("  a{} = m{};\n".format(firstCap(a.name), firstCap(a.name)))
     else:
-        fd.write("  *a%s = m%s;\n" % (firstCap(a.name), firstCap(a.name)))
+        fd.write("  *a{} = m{};\n".format(firstCap(a.name), firstCap(a.name)))
     fd.write("  return NS_OK;\n");
     fd.write("}\n\n");
 
@@ -186,7 +186,7 @@ def interfaces(iface):
 def allAttributes(iface):
     attributes = []
     for i in interfaces(iface):
-        attrs = filter(lambda m: isinstance(m, xpidl.Attribute), i.members)
+        attrs = [m for m in i.members if isinstance(m, xpidl.Attribute)]
         attributes.extend(attrs)
 
     return attributes
@@ -194,7 +194,7 @@ def allAttributes(iface):
 def write_cpp(eventname, iface, fd):
     classname = "xpcAcc%s" % eventname
     attributes = allAttributes(iface)
-    ccattributes = filter(lambda m: m.realtype.nativeType('in').endswith('*'), attributes)
+    ccattributes = [m for m in attributes if m.realtype.nativeType('in').endswith('*')]
     fd.write("NS_IMPL_CYCLE_COLLECTION(%s" % classname)
     for c in ccattributes:
         fd.write(", m%s" % firstCap(c.name))
diff --git a/build/appini_header.py b/build/appini_header.py
index 356a0692e7..f87adf30d4 100644
--- a/build/appini_header.py
+++ b/build/appini_header.py
@@ -5,11 +5,11 @@
 '''Parses a given application.ini file and outputs the corresponding
    XULAppData structure as a C++ header file'''
 
-import ConfigParser
+import configparser
 import sys
 
 def main(output, file):
-    config = ConfigParser.RawConfigParser()
+    config = configparser.RawConfigParser()
     config.read(file)
     flags = set()
     try:
@@ -20,15 +20,14 @@ def main(output, file):
         if config.getint('Crash Reporter', 'Enabled') == 1:
             flags.add('NS_XRE_ENABLE_CRASH_REPORTER')
     except: pass
-    appdata = dict(("%s:%s" % (s, o), config.get(s, o)) for s in config.sections() for o in config.options(s))
+    appdata = {"{}:{}".format(s, o): config.get(s, o) for s in config.sections() for o in config.options(s)}
     appdata['flags'] = ' | '.join(flags) if flags else '0'
     appdata['App:profile'] = '"%s"' % appdata['App:profile'] if 'App:profile' in appdata else 'NULL'
     expected = ('App:vendor', 'App:name', 'App:remotingname', 'App:version', 'App:buildid',
                 'App:id', 'Gecko:minversion', 'Gecko:maxversion')
     missing = [var for var in expected if var not in appdata]
     if missing:
-        print >>sys.stderr, \
-            "Missing values in %s: %s" % (file, ', '.join(missing))
+        print("Missing values in {}: {}".format(file, ', '.join(missing)), file=sys.stderr)
         sys.exit(1)
 
     if not 'Crash Reporter:serverurl' in appdata:
@@ -57,4 +56,4 @@ if __name__ == '__main__':
     if len(sys.argv) != 1:
         main(sys.stdout, sys.argv[1])
     else:
-        print >>sys.stderr, "Usage: %s /path/to/application.ini" % sys.argv[0]
+        print("Usage: %s /path/to/application.ini" % sys.argv[0], file=sys.stderr)
diff --git a/build/build-clang/build-clang.py b/build/build-clang/build-clang.py
index 697bbb9b8b..30ac7f5ec7 100755
--- a/build/build-clang/build-clang.py
+++ b/build/build-clang/build-clang.py
@@ -34,7 +34,7 @@ def symlink(source, link_name):
 def check_run(args):
     global DEBUG
     if DEBUG:
-        print >> sys.stderr, ' '.join(args)
+        print(' '.join(args), file=sys.stderr)
     r = subprocess.call(args)
     assert r == 0
 
@@ -43,11 +43,11 @@ def run_in(path, args):
     d = os.getcwd()
     global DEBUG
     if DEBUG:
-        print >> sys.stderr, 'cd "%s"' % path
+        print('cd "%s"' % path, file=sys.stderr)
     os.chdir(path)
     check_run(args)
     if DEBUG:
-        print >> sys.stderr, 'cd "%s"' % d
+        print('cd "%s"' % d, file=sys.stderr)
     os.chdir(d)
 
 
@@ -93,7 +93,7 @@ def build_tar_package(tar, name, base, directory):
 def copy_dir_contents(src, dest):
     for f in glob.glob("%s/*" % src):
         try:
-            destname = "%s/%s" % (dest, os.path.basename(f))
+            destname = "{}/{}".format(dest, os.path.basename(f))
             if os.path.isdir(f):
                 shutil.copytree(f, destname)
             else:
@@ -378,7 +378,7 @@ if __name__ == "__main__":
         extra_cxxflags2 = ["-fPIC", "-static-libstdc++"]
 
         if os.environ.has_key('LD_LIBRARY_PATH'):
-            os.environ['LD_LIBRARY_PATH'] = '%s/lib64/:%s' % (gcc_dir, os.environ['LD_LIBRARY_PATH']);
+            os.environ['LD_LIBRARY_PATH'] = '{}/lib64/:{}'.format(gcc_dir, os.environ['LD_LIBRARY_PATH']);
         else:
             os.environ['LD_LIBRARY_PATH'] = '%s/lib64/' % gcc_dir
     elif is_windows():
diff --git a/build/checksums.py b/build/checksums.py
index 9b13b50cb4..abecbe5b6a 100755
--- a/build/checksums.py
+++ b/build/checksums.py
@@ -81,9 +81,9 @@ def process_files(files, output_filename, digests, strip):
                         short_file = short_file.lstrip('/')
                     else:
                         short_file = file
-                    print >>output, '%s %s %s %s' % (hash, digest,
+                    print('%s %s %s %s' % (hash, digest,
                                                      os.path.getsize(file),
-                                                     short_file)
+                                                     short_file), file=output)
 
 def setup_logging(level=logging.DEBUG):
     '''This function sets up the logging module using a speficiable logging
@@ -140,7 +140,7 @@ def main():
     try:
         for digest in options.digests:
             hashlib.new(digest)
-    except ValueError, ve:
+    except ValueError as ve:
         logger.error('Could not create a "%s" hash object (%s)' %
                      (digest, ve.args[0]))
         exit(1)
diff --git a/build/compare-mozconfig/compare-mozconfigs-wrapper.py b/build/compare-mozconfig/compare-mozconfigs-wrapper.py
index e1888eed7e..0950b0231d 100644
--- a/build/compare-mozconfig/compare-mozconfigs-wrapper.py
+++ b/build/compare-mozconfig/compare-mozconfigs-wrapper.py
@@ -3,7 +3,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import unicode_literals
 
 import logging
 import mozunit
diff --git a/build/compare-mozconfig/compare-mozconfigs.py b/build/compare-mozconfig/compare-mozconfigs.py
index 876e336fe5..d5422f3c50 100644
--- a/build/compare-mozconfig/compare-mozconfigs.py
+++ b/build/compare-mozconfig/compare-mozconfigs.py
@@ -5,13 +5,12 @@
 
 # originally from http://hg.mozilla.org/build/tools/file/4ab9c1a4e05b/scripts/release/compare-mozconfigs.py
 
-from __future__ import unicode_literals
 
 import logging
 import os
 import site
 import sys
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 import difflib
 
 FAILURE_CODE = 1
@@ -26,7 +25,7 @@ def make_hg_url(hgHost, repoPath, protocol='https', revision=None,
                 filename=None):
     """construct a valid hg url from a base hg url (hg.mozilla.org),
     repoPath, revision and possible filename"""
-    base = '%s://%s' % (protocol, hgHost)
+    base = '{}://{}'.format(protocol, hgHost)
     repo = '/'.join(p.strip('/') for p in [base, repoPath])
     if not filename:
         if not revision:
@@ -40,15 +39,15 @@ def make_hg_url(hgHost, repoPath, protocol='https', revision=None,
 
 def readConfig(configfile, keys=[], required=[]):
     c = {}
-    execfile(configfile, c)
+    exec(compile(open(configfile, "rb").read(), configfile, 'exec'), c)
     for k in keys:
         c = c[k]
-    items = c.keys()
+    items = list(c.keys())
     err = False
     for key in required:
         if key not in items:
             err = True
-            log.error("Required item `%s' missing from %s" % (key, c))
+            log.error("Required item `{}' missing from {}".format(key, c))
     if err:
         raise ConfigError("Missing at least one item in config, see above")
     return c
@@ -100,7 +99,7 @@ def verify_mozconfigs(mozconfig_pair, nightly_mozconfig_pair, platform,
                             mozconfigWhitelist['nightly'][platform]:
                         continue
                     else:
-                        log.warning("%s not in %s %s!" % (
+                        log.warning("{} not in {} {}!".format(
                             clean_line, platform,
                             mozconfigWhitelist['nightly'][platform]))
             else:
@@ -122,11 +121,11 @@ def get_mozconfig(path, options):
     specified should be relative to the root of the hg
     repository e.g browser/config/mozconfigs/linux32/nightly"""
     if options.no_download:
-        return open(path, 'r').readlines()
+        return open(path).readlines()
     else:
         url = make_hg_url(options.hghost, options.branch, 'http',
                     options.revision, path)
-        return urllib2.urlopen(url).readlines()
+        return six.moves.urllib.request.urlopen(url).readlines()
 
 if __name__ == '__main__':
     from optparse import OptionParser
diff --git a/build/gen_test_packages_manifest.py b/build/gen_test_packages_manifest.py
index 1e2a7c3bba..4160774196 100644
--- a/build/gen_test_packages_manifest.py
+++ b/build/gen_test_packages_manifest.py
@@ -68,7 +68,7 @@ def generate_package_data(args):
     tests_common = args.tests_common
     jsshell = args.jsshell
 
-    harness_requirements = dict([(k, [tests_common]) for k in ALL_HARNESSES])
+    harness_requirements = {k: [tests_common] for k in ALL_HARNESSES}
     harness_requirements['jittest'].append(jsshell)
     for harness in PACKAGE_SPECIFIED_HARNESSES + OPTIONAL_PACKAGES:
         pkg_name = getattr(args, harness, None)
diff --git a/build/mach_bootstrap.py b/build/mach_bootstrap.py
index 22eaa3425a..f393c8f320 100644
--- a/build/mach_bootstrap.py
+++ b/build/mach_bootstrap.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import print_function, unicode_literals
 
 import errno
 import json
@@ -12,7 +11,7 @@ import random
 import subprocess
 import sys
 import uuid
-import __builtin__
+import builtins
 
 from types import ModuleType
 
@@ -41,7 +40,7 @@ SEARCH_PATHS = [
     'python/blessings',
     'python/compare-locales',
     'python/configobj',
-    'python/futures',
+    # 'python/futures',  # Python 3 has concurrent.futures built-in
     'python/jsmin',
     'python/psutil',
     'python/pylru',
@@ -173,9 +172,9 @@ def bootstrap(topsrcdir, mozilla_dir=None):
     # Ensure we are running Python 2.7+. We put this check here so we generate a
     # user-friendly error message rather than a cryptic stack trace on module
     # import.
-    if sys.version_info[0] != 2 or sys.version_info[1] < 7:
-        print('Python 2.7 or above (but not Python 3) is required to run mach.')
-        print('You are running Python', platform.python_version())
+    if sys.version_info[0] < 3:
+        print('Python 3 is required to run mach.')
+        print(('You are running Python', platform.python_version()))
         sys.exit(1)
 
     # Global build system and mach state is stored in a central directory. By
@@ -233,10 +232,14 @@ def bootstrap(topsrcdir, mozilla_dir=None):
         ))
 
         if platform.system() == 'Linux':
-            dist = list(platform.linux_distribution())
+            try:
+                import distro
+                dist = [distro.name(), distro.version(), distro.codename()]
+            except ImportError:
+                dist = ['', '', '']
             data['system']['linux_distribution'] = dist
         elif platform.system() == 'Windows':
-            win32_ver=list((platform.win32_ver())),
+            win32_ver=list(platform.win32_ver()),
             data['system']['win32_ver'] = win32_ver
         elif platform.system() == 'Darwin':
             # mac version is a special Cupertino snowflake
@@ -350,7 +353,7 @@ def bootstrap(topsrcdir, mozilla_dir=None):
 # and caveats.
 # Objdirs outside the source directory are ignored because in most cases, if
 # a .pyc/.pyo file exists there, a .py file will be next to it anyways.
-class ImportHook(object):
+class ImportHook:
     def __init__(self, original_import):
         self._original_import = original_import
         # Assume the source directory is the parent directory of the one
@@ -360,7 +363,7 @@ class ImportHook(object):
         self._modules = set()
 
     def __call__(self, name, globals=None, locals=None, fromlist=None,
-                 level=-1):
+                 level=0):
         # name might be a relative import. Instead of figuring out what that
         # resolves to, which is complex, just rely on the real import.
         # Since we don't know the full module name, we can't check sys.modules,
@@ -409,4 +412,4 @@ class ImportHook(object):
 
 
 # Install our hook
-__builtin__.__import__ = ImportHook(__builtin__.__import__)
+builtins.__import__ = ImportHook(builtins.__import__)
diff --git a/build/moz.configure/init.configure b/build/moz.configure/init.configure
index 7869764870..79ba7a8e68 100644
--- a/build/moz.configure/init.configure
+++ b/build/moz.configure/init.configure
@@ -133,7 +133,7 @@ option(env='PYTHON', nargs=1, help='Python interpreter')
 @imports(_from='mozbuild.configure.util', _import='LineIO')
 @imports(_from='mozbuild.virtualenv', _import='VirtualenvManager')
 @imports(_from='mozbuild.virtualenv', _import='verify_python_version')
-@imports('distutils.sysconfig')
+@imports('sysconfig')
 def virtualenv_python(env_python, build_env, mozconfig, help):
     if help:
         return
@@ -193,7 +193,7 @@ def virtualenv_python(env_python, build_env, mozconfig, help):
         sys.exit(subprocess.call([python] + sys.argv))
 
     # We are now in the virtualenv
-    if not distutils.sysconfig.get_python_lib():
+    if not sysconfig.get_path('purelib'):
         die('Could not determine python site packages directory')
 
     return python
@@ -212,7 +212,7 @@ def early_options():
     def early_options():
         return set(
             option.env
-            for option in __sandbox__._options.itervalues()
+            for option in __sandbox__._options.values()
             if option.env
         )
     return early_options
@@ -240,17 +240,17 @@ def mozconfig_options(mozconfig, help):
                 log.info('  %s' % arg)
                 helper.add(arg, origin='mozconfig', args=helper._args)
 
-        for key, value in mozconfig['env']['added'].iteritems():
+        for key, value in mozconfig['env']['added'].items():
             add(key, value)
             os.environ[key] = value
-        for key, (_, value) in mozconfig['env']['modified'].iteritems():
+        for key, (_, value) in mozconfig['env']['modified'].items():
             add(key, value)
             os.environ[key] = value
-        for key, value in mozconfig['vars']['added'].iteritems():
+        for key, value in mozconfig['vars']['added'].items():
             # mozconfig_loader adds _IS_SET variables that are irrelevant
             if not key.endswith('_IS_SET'):
                 add(key, value)
-        for key, (_, value) in mozconfig['vars']['modified'].iteritems():
+        for key, (_, value) in mozconfig['vars']['modified'].items():
             add(key, value)
 
 
@@ -400,7 +400,12 @@ def split_triplet(triplet):
 def config_sub(shell, triplet):
     config_sub = os.path.join(os.path.dirname(__file__), '..',
                               'autoconf', 'config.sub')
-    return subprocess.check_output([shell, config_sub, triplet]).strip()
+    result = subprocess.check_output([shell, config_sub, triplet]).strip()
+    try:
+        result = result.decode('utf-8')
+    except AttributeError:
+        pass
+    return result
 
 
 @depends('--host', shell)
@@ -411,6 +416,10 @@ def host(value, shell):
         config_guess = os.path.join(os.path.dirname(__file__), '..',
                                     'autoconf', 'config.guess')
         host = subprocess.check_output([shell, config_guess]).strip()
+        try:
+            host = host.decode('utf-8')
+        except AttributeError:
+            pass
     else:
         host = value[0]
 
@@ -761,7 +770,7 @@ def enabled_in_nightly(milestone, _):
 def all_configure_options(_):
     result = []
     previous = None
-    for option in __sandbox__._options.itervalues():
+    for option in __sandbox__._options.values():
         # __sandbox__._options contains items for both option.name and
         # option.env. But it's also an OrderedDict, meaning both are
         # consecutive.
diff --git a/build/moz.configure/old.configure b/build/moz.configure/old.configure
index e08d093080..ba9200172e 100644
--- a/build/moz.configure/old.configure
+++ b/build/moz.configure/old.configure
@@ -79,7 +79,7 @@ def prepare_configure(old_configure, mozconfig, awk, m4, build_env, shell,
 
         # Make old-configure append to config.log, where we put our own log.
         # This could be done with a m4 macro, but it's way easier this way
-        script = script.replace('>./config.log', '>>./config.log')
+        script = script.replace(b'>./config.log', b'>>./config.log')
 
         with open(old_configure, 'wb') as fh:
             fh.write(script)
@@ -346,7 +346,7 @@ def old_configure(prepare_configure, extra_old_configure_args, all_options,
         # Every variation of the exec() function I tried led to:
         # SyntaxError: unqualified exec is not allowed in function 'main' it
         # contains a nested function with free variables
-        exec code in raw_config
+        exec(code, raw_config)
 
     # Ensure all the flags known to old-configure appear in the
     # @old_configure_options above.
@@ -380,9 +380,9 @@ def set_old_configure_define(name, value):
 def post_old_configure(raw_config):
     for k, v in raw_config['substs']:
         set_old_configure_config(
-            k[1:-1], v[1:-1] if isinstance(v, types.StringTypes) else v)
+            k[1:-1], v[1:-1] if isinstance(v, str) else v)
 
-    for k, v in dict(raw_config['defines']).iteritems():
+    for k, v in dict(raw_config['defines']).items():
         set_old_configure_define(k[1:-1], v[1:-1])
 
     set_old_configure_config('non_global_defines',
diff --git a/build/moz.configure/toolchain.configure b/build/moz.configure/toolchain.configure
index de45e74744..04b7bc4ba7 100644
--- a/build/moz.configure/toolchain.configure
+++ b/build/moz.configure/toolchain.configure
@@ -236,7 +236,7 @@ def get_compiler_info(compiler, language):
         ('CPU', CPU_preprocessor_checks),
         ('KERNEL', kernel_preprocessor_checks),
     ):
-        for n, (value, condition) in enumerate(preprocessor_checks.iteritems()):
+        for n, (value, condition) in enumerate(preprocessor_checks.items()):
             check += dedent('''\
                 #%(if)s %(condition)s
                 %%%(name)s "%(value)s"
@@ -269,7 +269,7 @@ def get_compiler_info(compiler, language):
     # have non-ASCII characters. Treat the output as bytearray.
     data = {}
     for line in result.splitlines():
-        if line.startswith(b'%'):
+        if line.startswith('%'):
             k, _, v = line.partition(' ')
             k = k.lstrip('%')
             data[k] = v.replace(' ', '').lstrip('"').rstrip('"')
@@ -601,7 +601,7 @@ def compiler(language, host_or_target, c_compiler=None, other_compiler=None,
             if cross_compiling and other_compiler.type == 'clang':
                 return namespace(**{
                     k: [] if k == 'flags' else v
-                    for k, v in other_compiler.__dict__.iteritems()
+                    for k, v in other_compiler.__dict__.items()
                 })
 
     # Normally, we'd use `var` instead of `_var`, but the interaction with
diff --git a/build/moz.configure/util.configure b/build/moz.configure/util.configure
index 6bb97574c2..4860c339de 100644
--- a/build/moz.configure/util.configure
+++ b/build/moz.configure/util.configure
@@ -35,6 +35,10 @@ def check_cmd_output(*args, **kwargs):
         stdout, stderr = proc.communicate()
         retcode = proc.wait()
         if retcode == 0:
+            try:
+                stdout = stdout.decode('utf-8', errors='replace')
+            except AttributeError:
+                pass
             return stdout
 
         log.debug('The command returned non-zero exit status %d.',
diff --git a/build/pgo/genpgocert.py b/build/pgo/genpgocert.py
index c58bcd40d6..30f4aa2e1a 100644
--- a/build/pgo/genpgocert.py
+++ b/build/pgo/genpgocert.py
@@ -21,9 +21,9 @@ from mozfile import NamedTemporaryFile
 from mozprofile.permissions import ServerLocations
 
 dbFiles = [
-  re.compile("^cert[0-9]+\.db$"),
-  re.compile("^key[0-9]+\.db$"),
-  re.compile("^secmod\.db$")
+  re.compile(r"^cert[0-9]+\.db$"),
+  re.compile(r"^key[0-9]+\.db$"),
+  re.compile(r"^secmod\.db$")
 ]
 
 def unlinkDbFiles(path):
@@ -48,7 +48,7 @@ def runUtil(util, args, inputdata = None):
     pathvar = "LD_LIBRARY_PATH"
     app_path = os.path.dirname(util)
     if pathvar in env:
-      env[pathvar] = "%s%s%s" % (app_path, os.pathsep, env[pathvar])
+      env[pathvar] = "{}{}{}".format(app_path, os.pathsep, env[pathvar])
     else:
       env[pathvar] = app_path
   proc = subprocess.Popen([util] + args, env=env,
@@ -58,7 +58,7 @@ def runUtil(util, args, inputdata = None):
 
 
 def createRandomFile(randomFile):
-  for count in xrange(0, 2048):
+  for count in range(0, 2048):
     randomFile.write(chr(random.randint(0, 255)))
 
 
@@ -125,14 +125,14 @@ def createSSLServerCertificate(build, srcDir):
     iterator = iter(locations)
 
     # Skips the first entry, I don't know why: bug 879740
-    iterator.next()
+    next(iterator)
 
     locationsParam = ""
     firstLocation = ""
     for loc in iterator:
       if loc.scheme == "https" and "nocert" not in loc.options:
         customCertOption = False
-        customCertRE = re.compile("^cert=(?:\w+)")
+        customCertRE = re.compile(r"^cert=(?:\w+)")
         for option in loc.options:
           match = customCertRE.match(option)
           if match:
@@ -148,7 +148,7 @@ def createSSLServerCertificate(build, srcDir):
             firstLocation = loc.host
 
     if not firstLocation:
-      print "Nothing to generate, no automatic secure hosts specified"
+      print("Nothing to generate, no automatic secure hosts specified")
     else:
       createRandomFile(rndfile)
 
@@ -162,7 +162,7 @@ def createSSLServerCertificate(build, srcDir):
   return 0
 
 if len(sys.argv) == 1:
-  print "Specify --gen-server or --gen-ca"
+  print("Specify --gen-server or --gen-ca")
   sys.exit(1)
 
 build = MozbuildObject.from_environment()
@@ -170,23 +170,23 @@ certdir = os.path.join(build.topsrcdir, "build", "pgo", "certs")
 if sys.argv[1] == "--gen-server":
   certificateStatus = createSSLServerCertificate(build, certdir)
   if certificateStatus:
-    print "TEST-UNEXPECTED-FAIL | SSL Server Certificate generation"
+    print("TEST-UNEXPECTED-FAIL | SSL Server Certificate generation")
 
   sys.exit(certificateStatus)
 
 if sys.argv[1] == "--gen-ca":
   certificateStatus = createCertificateAuthority(build, certdir)
   if certificateStatus:
-    print "TEST-UNEXPECTED-FAIL | Certificate Authority generation"
+    print("TEST-UNEXPECTED-FAIL | Certificate Authority generation")
   else:
-    print "\n\n"
-    print "==================================================="
-    print " IMPORTANT:"
-    print " To use this new certificate authority in tests"
-    print " run 'make' at testing/mochitest"
-    print "==================================================="
+    print("\n\n")
+    print("===================================================")
+    print(" IMPORTANT:")
+    print(" To use this new certificate authority in tests")
+    print(" run 'make' at testing/mochitest")
+    print("===================================================")
 
   sys.exit(certificateStatus)
 
-print "Invalid option specified"
+print("Invalid option specified")
 sys.exit(1)
diff --git a/build/pgo/profileserver.py b/build/pgo/profileserver.py
index adc93d9b13..34416f72e8 100644
--- a/build/pgo/profileserver.py
+++ b/build/pgo/profileserver.py
@@ -63,7 +63,7 @@ if __name__ == '__main__':
 
             vcdir = os.path.abspath(os.path.join(env[e], '../../VC/bin'))
             if os.path.exists(vcdir):
-                env['PATH'] = '%s;%s' % (vcdir, env['PATH'])
+                env['PATH'] = '{};{}'.format(vcdir, env['PATH'])
                 break
 
     # Run Firefox a first time to initialize its profile
@@ -77,7 +77,7 @@ if __name__ == '__main__':
     jarlog = os.getenv("JARLOG_FILE")
     if jarlog:
       env["MOZ_JAR_LOG_FILE"] = os.path.abspath(jarlog)
-      print "jarlog: %s" % env["MOZ_JAR_LOG_FILE"]
+      print("jarlog: %s" % env["MOZ_JAR_LOG_FILE"])
 
     cmdargs = ["http://localhost:%d/index.html" % PORT]
     runner = FirefoxRunner(profile=profile,
diff --git a/build/ppCheck.py b/build/ppCheck.py
index 1e27ca1715..f072720bfa 100644
--- a/build/ppCheck.py
+++ b/build/ppCheck.py
@@ -1,9 +1,8 @@
 #!/usr/bin/env python
 
-from __future__ import print_function
 import os, sys
 
-if not len(sys.argv) is 2 or not os.path.exists(sys.argv[1]):
+if not len(sys.argv) == 2 or not os.path.exists(sys.argv[1]):
   print("\nYou did not supply a valid path to check.")
   exit(1)
 else:
@@ -65,7 +64,7 @@ PP_BAD_FILES = list(dict.fromkeys(PP_BAD_FILES))
 print('Done!')
 
 if len(PP_BAD_FILES) > 0:
-  print("\nWARNING: The following {0} file(s) in {1} may require preprocessing:\n".format(len(PP_BAD_FILES), DIST_PATH))
+  print("\nWARNING: The following {} file(s) in {} may require preprocessing:\n".format(len(PP_BAD_FILES), DIST_PATH))
   for file in PP_BAD_FILES:
     print(file)
 
